const mysql = require('mysql2')
const { HOST, DBUSER, PASSWORD, DATABASE  } = require('../config');

const mysqlConnection = mysql.createPool({
  connectionLimit: 10,
  host: HOST,
  user:  DBUSER,
  password: PASSWORD,
  database: DATABASE
})


mysqlConnection.getConnection((err, connection) => {
    if (err) {
      if (err.code === 'PROTOCOL_CONNECTION_LOST') {
        console.error('Database connection was closed.')
      }
      if (err.code === 'ER_CON_COUNT_ERROR') {
        console.error('Database has too many connections.')
      }
      if (err.code === 'ECONNREFUSED') {
        console.error('Database connection was refused.')
      }
    } if (connection) connection.release()
    return
  })
module.exports = mysqlConnection