const moment = require('moment');
const  datesModelo  = require('../models/dates');
const  horariosModelo  = require('../models/horarios');
const  asisitentesmusicosModelo  = require('../models/asisitentesmusicos');
const  asistentesNoMusicos  = require('../models/asistentesNoMusicos');
const  serviciosModelo  = require('../models/servicios');
const  serviciosAdicionalesModelo  = require('../models/serviciosAdicionales');
const  equipoestudioModelo  = require('../models/equipoestudio');
const  sesiondegrabacionService  = require('../services/sesiondegrabacion');
const  percentagesModelo  = require('../models/percentages');
const  preceivedPaymentsModelo  = require('../models/receivedPayments');


const deleteFechaAndHorarios = async (req, res) =>{      
    let result = await horariosModelo.deleteHorario(req.params.id);    
    if(result.code == 0)
    {
        let result2 = await datesModelo.deleteFechas(req.params.id);        
    }
    res.status(200).json({ result: true })
}

const deleteAsistenteMusico = async (req, res) =>{  
    let result = await asisitentesmusicosModelo.deleteMusicoById(req.params.id);
    res.status(200).json({ result: true })
}
const deleteAsistenteNoMusico = async (req, res) =>{  
    let result = await asistentesNoMusicos.deleteMusicoById(req.params.id);
    res.status(200).json({ result: true })
}

const deleteServiceAdditional = async (req, res) =>{  
    let result = await asistentesNoMusicos.deleteMusicoById(req.params.id);
    res.status(200).json({ result: true })
}
const deleteServicio = async (req, res) =>{  
    let result = await serviciosModelo.deleteService(req.params.id, req.params.sesionId);
    res.status(200).json({ result: true })
}

const deleteServicioAdicional = async (req, res) =>{  
    let result = await serviciosAdicionalesModelo.deleteService(req.params.id, req.params.sesionId);
    res.status(200).json({ result: true })
}
const deleteEquipoestudio = async (req, res) =>{  
    let result = await equipoestudioModelo.deleteEquipoEstudio(req.params.id);
    res.status(200).json({ result: true })
}

const deleteSesionDeGrabacion = async (req, res) => {
    let { idsesiongrabacion } = req.params;
    return res.json(await sesiondegrabacionService.deleteSesionDeGrabacion(idsesiongrabacion));
}

const deleteAditionalService = async (req, res) =>{
    let { id, idsesiongrabacion } = req.params;
    let userId = res.locals.userId;
    try {
        await serviciosModelo.deleteService(id, idsesiongrabacion);
        await serviciosModelo.deleteServiceById(id)
        await sesiondegrabacionService.generateAutomaticQuote(idsesiongrabacion, userId, null, null, null);
        res.status(200).json({ result: true })
    } catch (error) {
        res.status(500).json({ result: false })
    }

}
const deletePercentageById = async (req, res) => {
    try {
        let { id } = req.params;
        let result = await percentagesModelo.deletePercentageById(id);
        console.log(result);
        return res.status(200).json({ result: true });    
    } catch (error) {
        return res.status(500).json({ result: false });    
    }
    
}


const deleteReceivedPaymentById = async (req, res) =>{  
    let { id } = req.params;
    let result = await preceivedPaymentsModelo.deleteReceivedPaymentById(id);
    res.status(200).json({ result: true })
}



module.exports = {
    deleteFechaAndHorarios,
    deleteAsistenteMusico,
    deleteAsistenteNoMusico,
    deleteServicio,
    deleteServicioAdicional,
    deleteEquipoestudio,
    deleteSesionDeGrabacion,
    deleteAditionalService,
    deletePercentageById,
    deleteReceivedPaymentById
}