const  serviceModelo  = require('../models/service');
const  serviciosModelo  = require('../models/servicios');
const  serviciosAdicionalesModelo  = require('../models/serviciosAdicionales');
const  sesiongrabacionModelo  = require('../models/sesiongrabacion');
const  userModelo  = require('../models/User');
const  cotizacionesModelo  = require('../models/cotizaciones');
const  equipoestudioModelo  = require('../models/equipoestudio');
const auth = require('../auth');
const moment = require('moment');
const cotizacionService = require('../services/cotizaciones');
const  sesiondegrabacion  = require('../services/sesiondegrabacion');
const userRolesModelo  = require('../models/userRoles');
const locationsModelo = require('../models/locations')
const bitacoraModelo = require('../models/bitacora')
const { MAINURL } = require('../config');

const start = async (req, res) =>{ 
    return res.render('./start.html');
}

const logout = async (req, res) =>{        
    if (req.session) {       
        req.session.destroy();
    }
    return res.redirect('/');    
}

const login = async (req, res) =>{        
    const { method, id } = req.params;
    return res.render('./login.html', { email: 'josepabloosioavila@gmail.com', password: '371288009O$1o', msj: null,  method, id });    
    //return res.render('./login.html', { email: null, password: null, msj: null,  method, id });    
}

const menuv2 = async(req, res) => {
    res.locals.hideHeader = true;
    return res.render('./menuv2.html');    
}

const passwordReset = async (req, res) => {
    
    return res.render('./auth/passwordReset.html',{ post: false });
}

const adminsList = async (req, res) => {
    res.locals.hideHeader = true;
    let users = await userModelo.getAllActiveUsers();
    return res.render('./admin/adminsList.html', { users });
}

const newAdmin = async (req, res) => {
    res.locals.hideHeader = true;
    let pass = generateRandomPassword(10)
    return res.render('./admin/newAdmin.html', { pass });
}

const editAdmin = async (req, res) => {
    res.locals.hideHeader = true;
    let userId = req.params.id;
    let users = await userModelo.getUserById(userId)
    let roles = await userRolesModelo.getActiveRoles();
    return res.render('./admin/editAdmin.html', { user: users[0], roles });
}



const step3 = async (req, res) =>{
    let sesion_id = req.params.id;
    let from = req.params.from ? "admin": "user";
    if(from == "admin")
    {
        res.locals.hideHeader = true;
    }  
    return res.render('./step3.html', { 
        sesion_id,   
        from,        
    });    
}
const step4 = async (req, res) =>{
    let sesion_id = req.params.id;
    let from = req.params.from ? "admin": "user";
    if(from == "admin")
    {
        res.locals.hideHeader = true;
    }
    return res.render('./step4.html', { sesion_id, from });    
}
const step5 = async (req, res) =>{
    let sesion_id = req.params.id;
    let from = req.params.from ? "admin": "user";
    if(from == "admin")
    {
        res.locals.hideHeader = true;
    }
    let services = await serviceModelo.listActivaService()
    let aditionalservices = await serviceModelo.listServiceActivaAdditional()
    let checkedServices = await serviciosModelo.getCheckedServices(sesion_id)
    let checkedServicesAdicionales = await serviciosAdicionalesModelo.getCheckedServices(sesion_id)
    
    
    return res.render('./step5.html', { sesion_id, services, aditionalservices, checkedServices, checkedServicesAdicionales, from});    
}
const step6 = async (req, res) =>{
    let sesion_id = req.params.id;
    let from = req.params.from ? "admin": "user";
    if(from == "admin")
    {
        res.locals.hideHeader = true;
    }
    return res.render('./step6.html', { sesion_id, from });    
}
const step7 = async (req, res) =>{
    let sesion_id = req.params.id;
    let from = req.params.from ? "admin": "user";
    if(from == "admin")
    {
        res.locals.hideHeader = true;
    }
    let sesion = await sesiongrabacionModelo.getSesiongrabacion(sesion_id)    
    return res.render('./step7.html', { sesion_id, sesionE: sesion[0], from });    
}

const addHorasYfechas = async (req, res) => {
    res.locals.hideHeader = true;
    let { idsesiongrabacion } = req.params;
    let currentDate = moment();
    let locations = await locationsModelo.getActiveLocations();
    let servicios = await serviciosModelo.getActiveServices();
    let date = await currentDate.locale('es').format("YYYY-MM-DD")
    return res.render('./addHorasYfechas.html',{ idsesiongrabacion, locations, date, servicios});
}

const updateHorasYfechas = async (req, res) => {
    res.locals.hideHeader = true;
    let { idsesiongrabacion, fechaId } = req.params;
    let locations = await locationsModelo.getActiveLocations();
    let servicios = await serviciosModelo.getActiveServices();    
    let currentDate = moment();
    let date = await currentDate.locale('es').format("YYYY-MM-DD")
    return res.render('./updateHorasYfechas.html',{ idsesiongrabacion, fechaId, locations, date, servicios});
}

const calendarios = async (req, res) => {
    res.locals.hideHeader = true;
    let currentDate =   moment().locale('es').format("ll");    
    let currentYear = moment().year();
    let nextYear = currentYear + 1;
    let currentMonth = moment().month() + 1;
    return res.render('./admin/calendarios.html', { currentDate, currentYear, nextYear, currentMonth  });
}

const mainForm = async (req, res) => {       
    res.locals.hideHeader = true;
    let sesion_id = req.params.id;
    let sesions = await sesiongrabacionModelo.getSesiongrabacion(sesion_id); 
    let admins = await userModelo.getAllActiveUsers_Admins();
    let sesion = sesions[0];    
    let records = await bitacoraModelo.getBitacoraRecords(sesion_id);
    return res.render('./admin/mainForm.html', { sesion_id, sesion, admins, records });
}


const services = async (req, res) => {
    res.locals.hideHeader = true;
    let services = await serviciosModelo.getActiveServices();
    return res.render('./admin/services.html', { services });
}

const newService = async (req, res) => {
    res.locals.hideHeader = true;
    return res.render('./admin/newService.html');
}

const editService = async (req, res) => {
    res.locals.hideHeader = true;
    let services = await serviciosModelo.getServiceById(req.params.serviceId);
    let service = services[0];    
    return res.render('./admin/editService.html', { service });
}

const prices= async (req, res) => {
    res.locals.hideHeader = true; 
    let { id } = req.params;
    let pricesList = await serviciosModelo.getPricesByServiceId(id);
    let services = await serviciosModelo.getServiceById(id);
    let service = services[0];    
    return res.render('./admin/prices.html', { id,  pricesList, service });
}

const cotizacionesMenu = async (req, res) =>{  
    res.locals.hideHeader = true; 
    let idsesiongrabacion = req.params.idsesiongrabacion;
    let cotizaciones = await cotizacionesModelo.getCotizacionesByDdsesiongrabacion(idsesiongrabacion)
    let sesion =  await sesiongrabacionModelo.getSesiongrabacion(idsesiongrabacion);    
    let url = `${MAINURL}quotePeviewExternal/`
    return res.render('./admin/cotizacionesMenu.html', { idsesiongrabacion, cotizaciones, estatus_id: sesion[0].estatus_id, url });    
}

const cotizacion = async (req, res) =>{    
    res.locals.hideHeader = true;
    let user_id = res.locals.userId;
    let idsesiongrabacion = req.params.idsesiongrabacion;
    let cotizacionId = req.params.cotizacionId == undefined ? 0 : req.params.cotizacionId;
    let sesion =  await sesiongrabacionModelo.getSesiongrabacion(idsesiongrabacion)
    if(cotizacionId == 0)
    {
       let destinatarioNombre = sesion.nombreRepresentante ?? "Sin nombre";
       let destinatarioCorreo = sesion.email ?? "Sin correo electr贸nico";
       let destinatarioTelefono = sesion.telefono ?? "Sin tel茅fono";
       let { newCotizacionId } = await sesiondegrabacion.generateAutomaticQuote(idsesiongrabacion, user_id, destinatarioNombre, destinatarioCorreo, destinatarioTelefono) 
        cotizacionId = newCotizacionId;
    }
    let aditionalServices = await serviciosModelo.getAditionalServicesBy_SesiondegrabacionId(idsesiongrabacion);
    let user = await userModelo.getUserById(sesion[0].user_id)
    let data = await cotizacionesModelo.getAllCotizacionData(cotizacionId)   
    let newList = await sesiondegrabacion.getFechaYHorarioResumidos(idsesiongrabacion);       
    let equipoEstudio = await equipoestudioModelo.getAllEquipoEstudioById(idsesiongrabacion)
    return res.render('./admin/cotizacion.html', { idsesiongrabacion, sesion: sesion[0], user: user[0], data, newList, aditionalServices, equipoEstudio});    
}



const quotePeview = async (req, res) => {
    res.locals.hideHeader = true;
    let { cotizacionId, idsesiongrabacion }  = req.params;
    let { filePath, fileName } = await cotizacionService.generateCotizacion(cotizacionId)
    
    let hasSesion = true;
    return res.render('./admin/quotePeview.html', { filePath, fileName, idsesiongrabacion, hasSesion});
}

const quotePeviewexternal = async (req, res) => {
    res.locals.hideHeader = true;
    let hasSesion = false;
    let { cotizacionId, idsesiongrabacion }  = req.params;
    let { filePath, fileName } = await cotizacionService.generateCotizacion(cotizacionId)
    return res.render('./admin/quotePeview.html', { filePath, fileName, idsesiongrabacion, hasSesion});
}

const calculator = async (req, res) => {       
    res.locals.hideHeader = true; 
    let currentDate =   moment().locale('es').format("ll");        
    let currentYear = moment().year();
    let nextYear = currentYear + 1;
    let pastYear = currentYear - 1;
    let currentMonth = moment().month() + 1;
    let years = [pastYear, currentYear,  nextYear]
    let admins = await userModelo.getAllActiveUsers_Admins();
    return res.render('./admin/calculatorv2.html', { currentDate, currentYear, currentMonth, years, admins });
}

const calculatorv2 = async (req, res) => {       
    res.locals.hideHeader = true; 
    let currentDate =   moment().locale('es').format("ll");        
    let currentYear = moment().year();
    let nextYear = currentYear + 1;
    let pastYear = currentYear - 1;
    let currentMonth = moment().month() + 1;
    let years = [pastYear, currentYear,  nextYear]
    let admins = await userModelo.getAllActiveUsers_Admins();
    return res.render('./admin/calculatorv2.html', { currentDate, currentYear, currentMonth, years, admins });
}






const noticeOfPrivacy = async (req, res) => {
    return res.render('./noticeOfPrivacy.html');
}


const unsubscribe = async (req, res) => {
    return res.render('./unsubscribe.html',{ post: false });
}

const generateRandomPassword = (length) => {
    const charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
    let password = "";
    for (let i = 0; i < length; i++) {
      const randomIndex = Math.floor(Math.random() * charset.length);
      password += charset[randomIndex];
    }
    return password;
  }


const menu = async (req, res) =>{        
    let sesiones = [];
    let user_id = res.locals.userId;
    await sesiongrabacionModelo.deleteEmptySesions(user_id)
    if(res.locals.roleId !== 1)
    {
        return res.redirect('/menuv2');
    }
  
    sesiones = await sesiongrabacionModelo.getAllSesionsgrabacionByUserId(user_id);   
    return res.render('./menu.html', { sesiones });    
}


const bitacora = async(req, res) => {
    res.locals.hideHeader = true;
    let { idsesiongrabacion }  = req.params;
    let records = await bitacoraModelo.getBitacoraRecords(idsesiongrabacion);    
    return res.render('./admin/bitacora.html', { idsesiongrabacion, records });
}




const step2 = async (req, res) =>{
    let sesion_id = req.params.id;
    let from = req.params.from ? "admin": "user";
    let ingenierosDeAudio = await sesiongrabacionModelo.getIngenierosAudio();
    if(from == "admin")
    {
        res.locals.hideHeader = true;
    }
    let sesion = null;  
    if(sesion_id == undefined || sesion_id == null || sesion_id == 0)
    {
        let decoded = await auth.getDecodedDataFromToken(req);        
        let result = await sesiongrabacionModelo.createCita({ user_id: decoded.userId, estatus_id: 1 });        
        sesion_id = result.insertedID;        
    }
    sesion =  await sesiongrabacionModelo.getSesiongrabacion(sesion_id)
    return res.render('./step2.html', { sesion_id, sesion: sesion[0], from, ingenierosDeAudio });    
}



module.exports = {
    start,
    logout,
    login,
    menuv2,
    passwordReset,
    adminsList,
    newAdmin,
    editAdmin,
    step2,
    step3,
    step4,
    step5,
    step6,
    step7,
    addHorasYfechas,
    updateHorasYfechas,
    calendarios,
    mainForm,
    services,
    newService,
    editService,
    prices,
    cotizacionesMenu,
    cotizacion,
    quotePeview,
    quotePeviewexternal,
    calculator,
    calculatorv2,
    noticeOfPrivacy,
    unsubscribe,
    menu,
    bitacora




 

    
}