const  userModelo  = require('../models/User');
const  adminUserModelo  = require('../models/adminUser');
const  citaModelo  = require('../models/Reserve');
const  datesModelo  = require('../models/dates');
const  horariosModelo  = require('../models/horarios');
const  asistentesMusicosModelo  = require('../models/asisitentesmusicos');
const  asistentesNoMusicosModelo  = require('../models/asistentesNoMusicos');
const  sesiongrabacionModelo  = require('../models/sesiongrabacion');
const  serviciosModelo  = require('../models/servicios');
const  equipoestudioModelo  = require('../models/equipoestudio');
const  cotizacionesModelo  = require('../models/cotizaciones');
const  emailsMethods  = require('../emails/emailsMethods');
const  emailMethodsSES  = require('../emails/emailMethodsSES');
const  bitacoraModelo  = require('../models/bitacora');
const sesiondegrabacionService = require('../services/sesiondegrabacion');
const  percentagesModelo  = require('../models/percentages');
const  preceivedPaymentsModelo  = require('../models/receivedPayments');
const  auth  = require('../auth');
const moment = require('moment');


const signup = async (req, res) =>{  
    const { name,email, password } = req.body;    
    try {  
      let existe = await userModelo.validarExisteCorreo(email);
  
      if (existe.length === 0) {
  
          let user= await userModelo.registrar(name,email,password);
          let loginResult = await auth.login({ "lg-email": email,"lg-password": password });      
          if(loginResult.result)
          {            
              await req.session.regenerate( async function (err) {
                  if (err) next(err)          
                  req.session.token = loginResult.token;
                  let hour = 7400000;
                  req.session.cookie.maxAge = hour
                  await req.session.save(async function (err) {
                    if (err) return next(err)
                    if(user.codigo==0){
                      let newUser = await userModelo.getUser(email)
                      let result = await citaModelo.createCita({ user_id: newUser[0].id, estatus_id: 1 });
                      res.json({ result: true, message: 'User created successfully', newUser, sesionId: result.insertedID });
                    }else {
                      return res.status(500).json({ result: false,  error: 'Internal server error' });
                    }
                  })
                })          
          }
                 
      }else {          
        return res.status(409).json({  result: false,error: 'Email already registered' });
      }  
    }catch(error){
     console.log(error);
      return res.status(500).json({  result: false, error: 'Internal server error' });  
    }   
}
const signupAdmin = async (req, res) =>{  
  const { name,email, password } = req.body;      
  try {  
    let existe = await adminUserModelo.existsMail(email);
    if (existe.length === 0) {

        let user= await adminUserModelo.register(name,email,password);          
        if(user.codigo === 0)
        {
          return res.status(200).json({  result: true });   
        } 
        else
        {
          return res.status(500).json({  result: false, error: 'Internal server error' });  
        }
                                  
    }
    else 
    {          
      return res.status(409).json({  result: false,error: 'Email already registered' });
    }  
  }catch(error){
   console.log(error);
    return res.status(500).json({  result: false, error: 'Internal server error' });  
  }   
}
const updateCitaData = async (req, res) => {
  let { band_name, representant_name,  localidad_name, phone_name, session_id, ingeniero_audio} = req.body; 
  let result = await sesiongrabacionModelo.updateCita( band_name, representant_name, localidad_name, phone_name, session_id, ingeniero_audio );
  
  res.json({ result: true, message: 'Ok'  });
}
  const addDatetime = async (req, res) =>{  
    let {  date, checkedIds, sessionId, locationId } = req.body;        
    let selectedDate = await moment(date, 'YYYY-MM-DD');
    let result2 = await datesModelo.addDate(sessionId, selectedDate, locationId)    
    await Promise.all(checkedIds.map(async (id) =>{
      await horariosModelo.addHorario(id, result2.insertedID)
    }))  
    res.status(200).json({ result: true, sesion_id: sessionId })
  }
  const newMusico = async (req, res) =>{  
    let { nombre, telefono, email, instrumentos, sesionId } = req.body;    
    await asistentesMusicosModelo.addMusico( nombre, telefono, email, instrumentos, sesionId )
    res.status(200).json({ result: true })
  }
  const newNoMusico = async (req, res) =>{  
    try {
      let { nombre, telefono, funcion,  sesionId } = req.body;    
      await asistentesNoMusicosModelo.addAsistente( nombre, telefono, funcion,  sesionId  )
      res.status(200).json({ result: true })
    } catch (error) {
      console.log(error)
      res.status(500).json({ result: false })
    }
  
  }
  const updateMusico = async (req, res) =>{  
    let { nombre, telefono, email, instrumentos, id } = req.body;    
    await asistentesMusicosModelo.updateMusicoById(id,  nombre, telefono, email, instrumentos);
    res.status(200).json({ result: true })
  }
  const addService = async (req, res) =>{    
    let result = await serviciosModelo.addService(req.params.servicio_id, req.params.sesiongrabacion_id);     
    res.status(200).json({ result: true })
  }  
  const addEquipoestudio = async (req, res) =>{  
    let { nombre, marca, commentarios, sesionId } = req.body;
    await equipoestudioModelo.addEquipoEstudio(nombre, marca, commentarios, sesionId); 
    res.status(200).json({ result: true })
  }
  const loginPost = async (req, res) =>{    
    const { method, id } = req.params;
    let loginResult = await auth.login(req.body);
    if(loginResult.result)
    {
        await req.session.regenerate( async function (err) {
            if (err) next(err)          
            req.session.token = loginResult.token;
            let hour = 74000000;
            req.session.cookie.maxAge = hour
            await req.session.save(async function (err) {
              if (err) return next(err)
              if(loginResult.roleId !== 1)
              {
                if(method && id)
                {
                  return res.redirect(`/${method}/${id}`)
                }
                else
                {
                  return res.redirect('/menuv2')
                }
                
              }
              else
              {
                return res.redirect('/menu')
              }
              
            })
          })          
            }
    else
    {
      return res.render('./login.html',{ email: loginResult.email, password: loginResult.password, msj: loginResult.msj, method, id });   
    }    
}


const cotizacionPost = async(req, res) => {
  let idsesiongrabacion = req.params.idsesiongrabacion;
  let cotizacionId = req.params.idCotizacion;
  if(cotizacionId)
  {
    await cotizacionesModelo.updateCotizacionAndElements(idsesiongrabacion, cotizacionId,  req.body)  
    return res.redirect(`/cotizacion/${idsesiongrabacion}/${cotizacionId}`)
  }
  else
  {
    let newCotizacionId = await cotizacionesModelo.addCitizacion(idsesiongrabacion, req.body)  
    return res.redirect(`/cotizacion/${idsesiongrabacion}/${newCotizacionId}`)
  }
}

const sendQuotePost = async(req, res) => {
  let { cotizacionId, idsesiongrabacion  }  = req.params;
  let { inpt_name, inpt_email_1, inpt_email_2, inpt_email_3 } = req.body;
  let emailsList = [];
  emailsList.push(inpt_email_1);
  if(inpt_email_2)
  {
    emailsList.push(inpt_email_2);
  }
  if(inpt_email_3)
  {
    emailsList.push(inpt_email_3);
  }
  let cotizacion = await cotizacionesModelo.getCotizacion(cotizacionId)
  await emailMethodsSES.sendCotizacion(inpt_name, inpt_email_1, `acceptSesion/${idsesiongrabacion}`)
  await sesiongrabacionModelo.updateCitaToStatus(idsesiongrabacion, 3)
  return res.render('./admin/sendQuote.html', { fileName: cotizacion[0].fileName, idsesiongrabacion, cotizacion: cotizacion[0], post:true, result:true });
}
 

const passwordResetPost = async(req, res) => {
  let { inpt_email } = req.body;
  let email = inpt_email.trim();
  let result = await userModelo.existsMail(email)
   if(result.length > 0)
  {
     await userModelo.requestPasswordChange(email);
     await emailsMethods.sendPasswordReset(result[0].id, email, result[0].name, 1);
     
  }
  return res.render('./auth/passwordReset.html',{ post: true })
}


const passwordResetFormPost = async(req, res) => {
  let { inptPassword, inpt_userId, inpt_ut  } = req.body;
  let password = inptPassword;
  let userId = parseInt(inpt_userId);
  let ut = parseInt(inpt_ut);
  await userModelo.updatePassword(userId, password);
  return res.render('./auth/passwordResetForm.html', { enableForm: false, enablePostMsj: true })     
}
const newAdmin = async (req, res) => {
  res.locals.hideHeader = true;
  let { inpt_Name, inpt_Email, inpt_Password } = req.body
  let exist = await userModelo.existsMail(inpt_Email.trim())
  if(exist.length === 0)
  {
    await userModelo.registrar(inpt_Name, inpt_Email.trim(), inpt_Password)  
  }
  
  return res.redirect('/adminsList')
}


//(id, name, email, is_active, roleId)
const updateAdminPost = async (req, res) => {
  res.locals.hideHeader = true;
  const { inpt_Name, inpt_Email, inpt_Status, dd_Role } = req.body;
  let is_Active = inpt_Status ? 1: 0;
  let roleId = parseInt(dd_Role);
  await userModelo.updateUser(req.params.id, inpt_Name, inpt_Email, is_Active, roleId);
  let users = await userModelo.getAllActiveUsers();
  return res.render('./admin/adminsList.html', { users });
}

//informe, sesiongrabacion_id, user_id
const bitacoraPost = async (req, res) => {
  res.locals.hideHeader = true;
  let { idsesiongrabacion }  = req.params;
  let { inptComments } = req.body;
  let userId = res.locals.userId;
  await bitacoraModelo.insertBitacora(inptComments, idsesiongrabacion, userId)
  let records = await bitacoraModelo.getBitacoraRecords(idsesiongrabacion);
  return res.render('./admin/bitacora.html', { idsesiongrabacion, records });
}

const unsubscribePost = async (req, res) => {
  return res.render('./unsubscribe.html',{ post: true });
}
//    let { inpt_Selected_idsesiongrabacion, inpt_Selected_Location, inpt_Date} = req.body;
//const generateAutomaticQuote = async(sesiongrabacion_id, adminUserId, destinatarioNombre, destinatarioCorreo, destinatarioTelefono)
const addHorasYFechasPost = async (req, res) => {  
  //let userId = res.locals.userId;
  let userId = res.locals.userId;
  await sesiondegrabacionService.insertDateTimeServices(req)
  await sesiondegrabacionService.generateAutomaticQuote(req.body.inpt_Selected_idsesiongrabacion, userId, null, null, null);
  return res.redirect(`/paso3/${req.body.inpt_Selected_idsesiongrabacion}/admin`)
}

const updateHorasYFechasPost = async (req, res) => {  
  let userId = res.locals.userId;
  let idsesiongrabacion = req.body.inpt_Selected_idsesiongrabacion;
  await sesiondegrabacionService.updateDateTimeServices(req)
  await sesiondegrabacionService.generateAutomaticQuote(idsesiongrabacion,userId,null,null,null);
  return res.redirect(`/paso3/${idsesiongrabacion}/admin`)
}

const newServicePost = async (req,res) => {  
  let result = await serviciosModelo.addNewService(req.body.inpt_service, true);  
  await serviciosModelo.addServicePriceDefault(res.locals.userId, result.insertedID)
  return res.redirect(`/prices/${result.insertedID}`)
}
//(id, name, isActive)
const updateServicePost = async(req, res) => {
  let { inpt_service, chbx_Status } = req.body;
  let isActive = chbx_Status ? true : false;  
  await serviciosModelo.updateService(parseInt(req.params.id), inpt_service, isActive)  
  return res.redirect('/services')
}

const pricesPost = async(req, res) => {
   let user_id = res.locals.userId;
   await sesiondegrabacionService.updatePricesByServiceId(req.params.id, user_id, req.body)
   return res.redirect(`/prices/${req.params.id}`)
}


// servicio_id,sesiongrabacion_id)
const addAditionalService = async(req, res) => {
    let userId = res.locals.userId;
    let { insertedID } = await serviciosModelo.addNewService(req.body.service, false ,parseFloat(req.body.price))
    await serviciosModelo.addService(insertedID, req.params.session_id);
    await sesiondegrabacionService.generateAutomaticQuote(req.params.session_id, userId, null, null, null);
    return res.json({ result: true })
}
//(id, nombreServicio, isActive, costoHoraFromForm)
const upadateAditionalService = async(req, res) => {
  let userId = res.locals.userId;
  let {  id, name, price, session_id} = req.body;
  await serviciosModelo.updateService(parseInt(id), name, 1, parseFloat(price));
  await sesiondegrabacionService.generateAutomaticQuote(session_id, userId, null, null, null);
  return res.json({ result: true })
}


const addPercentageToCotizaciones = async(req, res) => {
  let { year, month, admin, percentage, justification } = req.body  
  let result = await cotizacionesModelo.addPercentageToCotizaciones(year, month, admin, percentage, justification );
  return res.json({ result })
}

const addPercentageIndiv = async(req, res) => {
  let {  cotizacionId, percentage, justification  } = req.body  
  await percentagesModelo.addPercentageIndiv(cotizacionId, percentage, justification);
  return res.json({ result: true })
}

const addReceivedPayment = async(req, res) => {
  let {  amount, year, month, user_id, comments  } = req.body  
  await preceivedPaymentsModelo.addReceivedPayment(amount, year, month, user_id, comments);
  return res.json({ result: true })
}


module.exports = {
    signup,
    signupAdmin,
    addDatetime,
    newMusico,
    newNoMusico,
    updateMusico,
    updateCitaData,
    addService,
    addAditionalService,
    addEquipoestudio,
    loginPost,
    cotizacionPost,
    // changeSesionStatusApprove,
    // changeSesionStatusRejected,
    sendQuotePost,
    passwordResetPost,
    passwordResetFormPost,
    newAdmin,
    updateAdminPost,
    bitacoraPost,
    unsubscribePost,
    addHorasYFechasPost,
    updateHorasYFechasPost,
    newServicePost,
    updateServicePost,
    pricesPost,
    upadateAditionalService,
    addPercentageToCotizaciones,
    addPercentageIndiv,
    addReceivedPayment
}