const { SESClient, SendEmailCommand  } = require("@aws-sdk/client-ses");
const path = require('path');
const ejs = require('ejs');
const { EMAILFROM, MAINURL, AWSACCESSKEYID, AWSSECRETACCESSKEY, AWSREGION  } = require('../config');



const user = EMAILFROM;


const client = new SESClient({
  credentials:{
    accessKeyId: AWSACCESSKEYID,
    secretAccessKey: AWSSECRETACCESSKEY
  },   
  region: AWSREGION,
});






const sendNewRequest = async(method, sesiongrabacion_id ,emailsToSend) => {
  try {  
    const html = await ejs.renderFile(path.join(__dirname, `/newRequest.ejs`), 
    {              
        url: `${MAINURL}login/${method}/${sesiongrabacion_id}`,
        mainUrl: MAINURL,
        unsubscribeUrl: `${MAINURL}/unsubscribe`,
        noticeOfPrivacyUrl: `${MAINURL}/avisodeprivacidad`
        }, 
        {async:true}
    );
    let params = {
      Source: user,
      Destination: {
          ToAddresses: emailsToSend,
      },
      ReplyToAddresses: [],
      Message: {
          Body: {
          Html: {
              Charset: 'UTF-8',
              Data: html,
          },
          },
          Subject: {
          Charset: 'UTF-8',
          Data: "emos recibido una nueva reservacion para el estudio.",
          }
      },
      };
    const command = new SendEmailCommand(params);
    const response = await client.send(command);
    return { result: true }
  } catch (error) {
    console.log(error)
    return { result: false  }
  }
   
}


const sendPasswordReset = async(userId, email, userName, tu) => {
  try {

    const html = await ejs.renderFile(path.join(__dirname, `/passwordReset.ejs`), 
    {
        
        name: userName, 
        url: `${MAINURL}passwordResetForm/${userId}/${tu}`,
        mainUrl: MAINURL,
        unsubscribeUrl: `${MAINURL}unsubscribe`,
        noticeOfPrivacyUrl: `${MAINURL}avisodeprivacidad`
        }, 
        {async:true}
    );
    let params = {
      Source: user,
      Destination: {
          ToAddresses: [
          email
          ],
      },
      ReplyToAddresses: [],
      Message: {
          Body: {
          Html: {
              Charset: 'UTF-8',
              Data: html,
          },
          },
          Subject: {
          Charset: 'UTF-8',
          Data: "Restablecimiento de contraseña.",
          }
      },
      };
    const command = new SendEmailCommand(params);
    const response = await client.send(command);

    return { result: true }
  } catch (error) {
    console.log(error)
    return { result: false  }
  }
   
}

const sendCotizacion = async(userName, fileName, email, emailsList, urlToAccept) => {
  try {
    const html = await ejs.renderFile(path.join(__dirname, `/cotizacion.ejs`), 
    {
        name: userName, 
        mainUrl: MAINURL,
        unsubscribeUrl: `${MAINURL}/unsubscribe`,
        noticeOfPrivacyUrl: `${MAINURL}/avisodeprivacidad`,
        urlAccept: `${MAINURL}${urlToAccept}`
        }, 
        {async:true}
    );
    let params = {
      Source: user,
      Destination: {
          ToAddresses: emailsList,
      },
      ReplyToAddresses: [],
      Message: {
          Body: {
          Html: {
              Charset: 'UTF-8',
              Data: html,
          },
          },
          Subject: {
          Charset: 'UTF-8',
          Data: "Cotización - Bunker studios",
          }
      },
      };
  const command = new SendEmailCommand(params);
  const response = await client.send(command);
    return { result: true, emailsList }
  } catch (error) {
    return { result: false, emailsList, error  }
  }
   
}
module.exports = { sendCotizacion, sendPasswordReset, sendNewRequest } 