const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');


  registrar= async (name,email, password) => {

    const hashedPassword = await bcrypt.hash(password, 10);
    let is_active = 1;
    let userRole_id = 2;
    let is_verified = 1;
    return new Promise((resolve, reject) => {

        const query = 'INSERT INTO users ( name,email, password,is_verified, is_active, userRole_id) VALUES (?,?, ?,?, ?, ?)';
    
        mysqlConnection.query(query, [ name,email, hashedPassword, is_verified, is_active, userRole_id], function (err,rows, result) {   
            if(!err){                                               
                resolve({
                  codigo: 0
                })
            }else{
              
                console.log(err)
                reject(err)
            }
        })
    })
  }

  validarExisteCorreo= async (email) => {

    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from users where  email='" + email + "'";
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){
               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getUser= async (email) => {

  return new Promise((resolve, reject) => {
      const queryPlaca = "select id, name, email from users where  email='" + email + "'";
      mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
          if(!err){
             
              resolve(rows)
          }else{
              console.log(err)
              reject(err)
          }
      })
  })
}

getUserById = async (id) => {
  return new Promise((resolve, reject) => {
      const queryPlaca = `select id, name, email, userRole_id, is_active from users where  id= ${id};`;
      mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
          if(!err){
             
              resolve(rows)
          }else{
              console.log(err)
              reject(err)
          }
      })
  })
}
actualizarEstadoCorreo= async (email) => {


  return new Promise((resolve, reject) => {

      const query = 'UPDATE users SET is_verified = 1 WHERE email = ?';
  
      mysqlConnection.query(query, [ email], function (err,rows, result) {   
          if(!err){
             
              resolve({
                codigo: 0
              })
          }else{
            
              console.log(err)
              reject(err)
          }
      })
  })
}


existsMail= (email) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from users where  email= ? and is_active = true ";
        mysqlConnection.query(queryPlaca,  [ email] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


getUserByIdForPasswordReset = (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from users where  id= ? and is_active = true and DATE(passwordResetRequestDate) = CURDATE();";
        mysqlConnection.query(queryPlaca,  [id] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



requestPasswordChange= (email) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "update users set passwordResetRequestDate = now()  where  email = ? and is_active = true ";
        mysqlConnection.query(queryPlaca,  [email] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


updatePassword = async (id, password) => {    
    const hashedPassword = await bcrypt.hash(password, 10);
    return new Promise((resolve, reject) => {
        const queryPlaca = "update users set password = ?, passwordResetRequestDate = null   where  id = ? and is_active = true ";
        mysqlConnection.query(queryPlaca,  [hashedPassword, id] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


getAllUsers = async() => {
    const query = "SELECT users.*, userRoles.name as roleName  FROM users left join userRoles on users.userRole_id = userRoles.id order by users.name asc;"
    return new Promise((resolve, reject) => {        
        mysqlConnection.query(query, function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

updateUser = async (id, name, email, is_active, roleId) => {    
    return new Promise((resolve, reject) => {
        const queryPlaca = "update users set name = ?, email = ?, is_active = ?, userRole_id = ?   where  id = ? ;";
        mysqlConnection.query(queryPlaca,  [name, email, is_active, roleId,  id]  , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getAllActiveUsers_Admins = async() =>{
    const query = `select users.*, userRoles.name as roleName from users 
    left join userRoles
    on users.userRole_id = userRoles.id
    where is_active = 1 and userRole_id in(2,3);`
    return new Promise((resolve, reject) => {        
        mysqlConnection.query(query, function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


getAllActiveUsers = async() =>{
    const query = `select users.*, userRoles.name as roleName from users 
    left join userRoles
    on users.userRole_id = userRoles.id
    where is_active = 1;`
    return new Promise((resolve, reject) => {        
        mysqlConnection.query(query, function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



//371288009O$1poo
  module.exports = {
    registrar,
    validarExisteCorreo,
    actualizarEstadoCorreo,
    getUser,
    getUserById,
    existsMail,
    requestPasswordChange,
    getUserByIdForPasswordReset,
    updatePassword,
    getAllUsers,
    updateUser,
    getAllActiveUsers_Admins,
    getAllActiveUsers
  }