const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');


register= async (name,email, password) => {

    const hashedPassword = await bcrypt.hash(password, 10);

    return new Promise((resolve, reject) => {

        const query = 'INSERT INTO adminusers ( name,email, password,is_verified, is_active) VALUES (?,?, ?,?, ?)';
    
        mysqlConnection.query(query, [ name,email, hashedPassword, 1, 1], function (err,rows, result) {   
            if(!err){
               
                resolve({
                  codigo: 0
                })
            }else{
              
                console.log(err)
                reject(err)
            }
        })
    })
  }

  existsMail= (email) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from adminusers where  email= ? and is_active = true ";
        mysqlConnection.query(queryPlaca,  [ email] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}




getUserByIdForPasswordReset = (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from adminusers where  id= ? and is_active = true and DATE(passwordResetRequestDate) = CURDATE();";
        mysqlConnection.query(queryPlaca,  [id] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


getUserById = (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from adminusers where  id= ?;";
        mysqlConnection.query(queryPlaca,  [id] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}




getAllUsers= () => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from adminusers order by id desc";
        mysqlConnection.query(queryPlaca,  function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


requestPasswordChange= (email) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "update adminusers set passwordResetRequestDate = now()  where  email= ? and is_active = true ";
        mysqlConnection.query(queryPlaca,  [email] , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



updateAdminUser = async (id, name, email, is_active) => {    
    return new Promise((resolve, reject) => {
        const queryPlaca = "update adminusers set name = ?, email = ?, is_active = ?   where  id = ? ;";
        mysqlConnection.query(queryPlaca,  [name, email, is_active, id]  , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



updatePassword = async (id, password) => {    
    const hashedPassword = await bcrypt.hash(password, 10);
    return new Promise((resolve, reject) => {
        const queryPlaca = "update adminusers set password = ?, passwordResetRequestDate = null   where  id = ? and is_active = true ";
        mysqlConnection.query(queryPlaca,  [hashedPassword, id]  , function (err,rows, result) {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


  module.exports = {
    register,
    existsMail,
    requestPasswordChange,
    getUserByIdForPasswordReset,
    updatePassword,
    getAllUsers,
    getUserById,
    updateAdminUser
  }