const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');

addMusico = async (nombre, telefono, email, instrumentos, sesionId) => {


    return new Promise((resolve, reject) => {

        const query = `INSERT INTO asistentesmusicos (nombre,telefono, email,instrumentos, sesiongrabacion_id) VALUES (?, ?, ?, ?, ?);`;
    
        mysqlConnection.query(query,[nombre, telefono, email, instrumentos, sesionId], (error, results) => { 
            if(!error){               
                const lastInsertedId = results.insertId;
                resolve({
                    insertedID: lastInsertedId
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
  }
  getMusicosById= (sesiongrabacion_id) => {

    return new Promise((resolve, reject) => {
        const queryPlaca = `select * from asistentesmusicos where  sesiongrabacion_id = ?;`;
        mysqlConnection.query(queryPlaca,[sesiongrabacion_id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}
  getMusicoById= (sesiongrabacion_id) => {

    return new Promise((resolve, reject) => {
        const queryPlaca = `select * from asistentesmusicos where  id = ?;`;
        mysqlConnection.query(queryPlaca,[sesiongrabacion_id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}
updateMusicoById= async (id, nombre, telefono, email, instrumentos) => {

    return new Promise((resolve, reject) => {
  
        const query = 'UPDATE asistentesmusicos SET nombre = ?, telefono = ?, email = ?, instrumentos = ?   WHERE id = ?' ;
    
        mysqlConnection.query(query, [nombre, telefono, email, instrumentos, id], function (err,rows, result) {   
            if(!err){
               
                resolve({
                  codigo: 0
                })
            }else{
              
                console.log(err)
                reject(err)
            }
        })
    })
}
deleteMusicoById= async (id) => {

    return new Promise((resolve, reject) => {
  
        const query = 'delete from asistentesmusicos  WHERE id = ?;' ;    
        mysqlConnection.query(query, [id], (err, result) => {
            if (err) {
              
              const response = {
                  code: -1,
                  mensaje: "Error al eliminar el registro"
                  };
      
                  resolve(response)
  
            } else {
              const response = {
                  code: 0,
                  mensaje: "Registro creado exitosamente"
              };
  
              resolve(response)
            }
          });
    })
}



deleteMusicosBySesiondegrabacionId= async (id) => {

    return new Promise((resolve, reject) => {
  
        const query = 'delete from asistentesmusicos  WHERE sesiongrabacion_id = ?;' ;    
        mysqlConnection.query(query, [id], (err, result) => {
            if (err) {
              
              const response = {
                  code: -1,
                  mensaje: "Error al eliminar el registro"
                  };
      
                  resolve(response)
  
            } else {
              const response = {
                  code: 0,
                  mensaje: "Registro creado exitosamente"
              };
  
              resolve(response)
            }
          });
    })
}


  module.exports = {
    addMusico,
    getMusicoById,
    getMusicosById,
    updateMusicoById,
    deleteMusicoById,
    deleteMusicosBySesiondegrabacionId
  }