const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');


addDate= (sesion_Id, date, location_id) => {
    return new Promise((resolve, reject) => {
        //const queryPlaca = `insert into sesiongrabacionfechas (date, sesiongrabacion_id, createdAt, updatedAt, location_id) values('${date.format('YYYY-MM-DD')}', ${sesion_Id}, NOW(), NOW(), ${location_id});`;
        const queryPlaca = `insert into sesiongrabacionfechas (date, sesiongrabacion_id, createdAt, updatedAt, location_id) values('${date}', ${sesion_Id}, NOW(), NOW(), ${location_id});`;
        mysqlConnection.query(queryPlaca, (error, results) => { 
            if(!error){               
                const lastInsertedId = results.insertId;
                resolve({
                    insertedID: lastInsertedId
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
}
getDateAndHorarioDraft= (sesiongrabacion_id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `SELECT *, (select GROUP_CONCAT(horarios.label SEPARATOR ', ') from sesiongrabacionhorarios left join horarios on sesiongrabacionhorarios.horario_id = horarios.id  where sesiongrabacionfechas_id = sesiongrabacionfechas.id order by 'order' asc) as horarios FROM sesiongrabacionfechas where sesiongrabacionfechas.sesiongrabacion_id = ${sesiongrabacion_id};`;
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getDatesBySesionGrabacionId = (sesiongrabacion_id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `SELECT sesiongrabacionfechas.*, locations.name FROM sesiongrabacionfechas left join locations on sesiongrabacionfechas.location_id = locations.id where sesiongrabacion_id = ${sesiongrabacion_id};`;
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



deleteFechas= (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `delete from sesiongrabacionfechas where id = ?; `;
        mysqlConnection.query(queryPlaca, [id], (err, result) => {
            if (err) {              
              const response = {
                  code: -1,
                  mensaje: "Error al eliminar el registro"
                  };
      
                  resolve(response)
  
            } else {
              const response = {
                  code: 0,
                  mensaje: "Registro creado exitosamente"
              };
  
              resolve(response)
            }
          });
    })
}



getDateByFechaId = (fechaId) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `SELECT * FROM sesiongrabacionfechas where id = ${fechaId};`;
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


getBusyDates = (year, month) => {
    let query = `SELECT sesiongrabacionfechas.*, DAY(sesiongrabacionfechas.date) dayNo FROM sesiongrabacionfechas
    left join sesiongrabacion
    on sesiongrabacionfechas.sesiongrabacion_id = sesiongrabacion.idsesiongrabacion
    where YEAR(date) = ? and MONTH(date) = ? and estatus_id = 2;`
    return new Promise((resolve, reject) => {        
        mysqlConnection.query(query, [year, month], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getBusyDatesByIds = (location_id, year, month, day) => {
    let query = `
    SELECT nombreBandaGrupo, nombreRepresentante, label, nombreServico,
    (case when users.name is null then 'Sin encargado' else users.name end) as encargado
      FROM sesiongrabacionhorarios horariosApartados
        left join sesiongrabacionfechas fechas
        on horariosApartados.sesiongrabacionfechas_id = fechas.id
        left join sesiongrabacion grabacion
        on fechas.sesiongrabacion_id = grabacion.idsesiongrabacion
        left join users
        on grabacion.whoSoldId = users.id
        left join horarios
        on horariosApartados.horario_id = horarios.id
        left join servicios
        on horariosApartados.servicio_id = servicios.id
        where 
    grabacion.estatus_id = 2
    and YEAR(fechas.date) = ?
    and MONTH(fechas.date) = ?
    and DAY(fechas.date) = ?
    and fechas.location_id = ?
    order by horarios.order asc;`
    console.log(query)
    return new Promise((resolve, reject) => {        
        mysqlConnection.query(query, [year, month, day, location_id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}







  module.exports = {
    addDate,
    getDateAndHorarioDraft,
    deleteFechas,
    getDatesBySesionGrabacionId,
    getDateByFechaId,
    getBusyDates,
    getBusyDatesByIds
  }