const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');

getEquipoEstudioById= (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from equipoestudio where id = ? ;";
        mysqlConnection.query(queryPlaca,[id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}
addEquipoEstudio= (nombre, marca, commentarios, sesiongrabacion_id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `insert into equipoestudio (nombre, marca, comentarios, sesiongrabacion_id) values(?,?,?,?);`;
        mysqlConnection.query(queryPlaca,[nombre, marca, commentarios, sesiongrabacion_id], (error, results) => { 
            if(!error){               
                const lastInsertedId = results.insertId;
                resolve({
                    insertedID: lastInsertedId
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
}
deleteEquipoEstudio= (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `delete from equipoestudio where id = ?; `;
        mysqlConnection.query(queryPlaca, [id], (err, result) => {
            if (err) {
              
              const response = {
                  code: -1,
                  mensaje: "Error al eliminar el registro"
                  };
      
                  resolve(response)
  
            } else {
              const response = {
                  code: 0,
                  mensaje: "Registro creado exitosamente"
              };
  
              resolve(response)
            }
          });
    })
}
getAllEquipoEstudioById= (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from equipoestudio where sesiongrabacion_id = ? order by 'nombre' asc ";
        mysqlConnection.query(queryPlaca,[id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}
updateEquipoEstudio= (nombre, marca, commentarios, id ) => {
    return new Promise((resolve, reject) => {       
        const sql = 'UPDATE equipoestudio SET nombre = ?, marca = ?, comentarios = ? WHERE id = ?';
         mysqlConnection.query(sql, [nombre, marca, commentarios, id], (err, result) => {
        if (err) {       
            const response = {
                code: -1,
                mensaje: "Error al crear el registro"
                };    
                resolve(response)
        } else {      
            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
                };    
                resolve(response)
        }
     });

       
 });

    
}


deleteAllEquipoEstudioBySesiongrabacion_id = (sesiongrabacion_id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `delete from equipoestudio where sesiongrabacion_id = ?; `;
        mysqlConnection.query(queryPlaca, [sesiongrabacion_id], (err, result) => {
            if (err) {
              
              const response = {
                  code: -1,
                  mensaje: "Error al eliminar el registro"
                  };
      
                  resolve(response)
  
            } else {
              const response = {
                  code: 0,
                  mensaje: "Registro creado exitosamente"
              };
  
              resolve(response)
            }
          });
    })
}



module.exports = {
    getEquipoEstudioById,
    getAllEquipoEstudioById,
    addEquipoEstudio,
    deleteEquipoEstudio,
    updateEquipoEstudio,
    deleteAllEquipoEstudioBySesiongrabacion_id
}



