const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');




getDateId = (date) => {
    console.log(date)
    return new Promise((resolve, reject) => {
        const queryPlaca = `
        select * from sesiongrabacionfechas 
left join sesiongrabacion 
on sesiongrabacion.idsesiongrabacion = sesiongrabacionfechas.sesiongrabacion_id
where sesiongrabacionfechas.date = STR_TO_DATE(?, '%d-%m-%Y')
and sesiongrabacion.estatus_id = 3;
        `;//, [date, sesion_id        
        mysqlConnection.query(queryPlaca, [date],  (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}
getHorariosByDateId = (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `
        select sesiongrabacionhorarios.*, horarios.label, horarios.order, horarios.inicio, horarios.fin, servicios.nombreServico
        from sesiongrabacionhorarios
        left join horarios 
        on sesiongrabacionhorarios.horario_id = horarios.id
        left join servicios
        on sesiongrabacionhorarios.servicio_id = servicios.id
        where sesiongrabacionfechas_id = ?
        order by horarios.order asc`;
        mysqlConnection.query(queryPlaca, [id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}
getActiveHorarios= (email) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from horarios where isActive = 1 order by 'order' asc ";
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}
addHorario= (horario_id, sesiongrabacionfechas_id, servicio_id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `insert into sesiongrabacionhorarios (horario_id, sesiongrabacionfechas_id, createdAt, updatedAt, servicio_id) values('${horario_id}', ${sesiongrabacionfechas_id}, NOW(), NOW(), ${servicio_id});`;
        mysqlConnection.query(queryPlaca, (error, results) => { 
            if(!error){               
                const lastInsertedId = results.insertId;
                resolve({
                    insertedID: lastInsertedId
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
}
deleteHorario= (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `delete from sesiongrabacionhorarios where sesiongrabacionfechas_id = ?; `;
        mysqlConnection.query(queryPlaca, [id], (err, result) => {
            if (err) {
              
              const response = {
                  code: -1,
                  mensaje: "Error al eliminar el registro"
                  };
      
                  resolve(response)
  
            } else {
              const response = {
                  code: 0,
                  mensaje: "Registro creado exitosamente"
              };
  
              resolve(response)
            }
          });
    })
}


getHoursByService = (id) => {
    let query = `SELECT count(*) qty, servicio_id, servicios.nombreServico FROM sesiongrabacionhorarios
    left join servicios 
    on sesiongrabacionhorarios.servicio_id = servicios.id
    left join sesiongrabacionfechas
    on sesiongrabacionhorarios.sesiongrabacionfechas_id = sesiongrabacionfechas.id
    where sesiongrabacionfechas.sesiongrabacion_id = ?
    group by servicio_id;`;
    return new Promise((resolve, reject) => {        
        mysqlConnection.query(query, [id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

  module.exports = {
    getActiveHorarios,
    addHorario,
    deleteHorario,
    getDateId,
    getHorariosByDateId,
    getHoursByService
  }