const mysqlConnection = require('../config/database');

getPercentagesByCotizacionIdGeneral = (cotizacionId) => {
    return new Promise((resolve, reject) => {
        const query = "SELECT * FROM cotizacionesporcentajes where cotizacionId = ?  order by id asc;";
        mysqlConnection.query(query,[cotizacionId], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getPercentageById = (id) => {
    return new Promise((resolve, reject) => {
        const query = "SELECT * FROM cotizacionesporcentajes where id = ?;";
        mysqlConnection.query(query,[id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

updatePercentageById = async (id, percentage, justification) => {
    return new Promise((resolve, reject) => {
        const query = `update cotizacionesporcentajes set percentage = ?, justification = ?, isGeneral = 0 where id = ?;`;
        mysqlConnection.query(query, [percentage, justification, id], (error) => {
            if (error) {
                    console.error('Error inserting availability:', error);
                    reject(error)
            } else {
                
                resolve({
                    codigo: 0
                })
            }
        });
    })
}
deletePercentageById = (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `delete from cotizacionesporcentajes where id = ?; `;
        mysqlConnection.query(queryPlaca, [id], (err, result) => {
            if (err) {
              
              const response = {
                  code: -1,
                  mensaje: "Error al eliminar el registro"
                  };
      
                  resolve(response)
  
            } else {
              const response = {
                  code: 0,
                  mensaje: "Registro creado exitosamente"
              };
  
              resolve(response)
            }
          });
    })
}


addPercentageIndiv= (cotizacionId, percentage, justification) => {

    return new Promise((resolve, reject) => {               
        const sql = 'INSERT INTO cotizacionesporcentajes (percentage, justification, timestamp, cotizacionId, isGeneral) VALUES (?, ?, now() ,?, 0)';
        mysqlConnection.query(sql, [percentage, justification, cotizacionId], (err, result) => {
          if (err) {
           const response = {
            code: -1,
            mensaje: "Error al crear el registro"
            };
            resolve(response)
          } else {
            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
                };    
                resolve(response)            
          }
        });

    })
}


module.exports = { 
    getPercentagesByCotizacionIdGeneral,
    getPercentageById,
    updatePercentageById,
    deletePercentageById,
    addPercentageIndiv
}