const mysqlConnection = require('../config/database');




getReceivedPayments = (year, month, user_id) => {
    return new Promise((resolve, reject) => {
        const query = "SELECT * FROM receivedPayments where year = ? and month = ? and user_id = ? and isActive = 1  order by id asc;";
        mysqlConnection.query(query,[year, month, user_id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


getReceivedPaymentById = (id) => {
    return new Promise((resolve, reject) => {
        const query = "SELECT * FROM receivedPayments where id = ?;";
        mysqlConnection.query(query,[id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



updateReceivedPaymentById = async (id, amount, comments) => {
    return new Promise((resolve, reject) => {
        const query = `update receivedPayments set amount = ?, comments = ? where id = ?;`;
        mysqlConnection.query(query, [amount, comments, id], (error) => {
            if (error) {
                    console.error('Error inserting availability:', error);
                    reject(error)
            } else {
                
                resolve({
                    codigo: 0
                })
            }
        });
    })
}



deleteReceivedPaymentById = (id) => {
    return new Promise((resolve, reject) => {
        const query = `update receivedPayments set isActive = 0 where id = ?;`;
        mysqlConnection.query(query, [id], (error) => {
            if (error) {
                    console.error('Error inserting availability:', error);
                    reject(error)
            } else {
                
                resolve({
                    codigo: 0
                })
            }
        });
    })
}


addReceivedPayment = (amount, year, month, user_id, comments) => {

    return new Promise((resolve, reject) => {               
        const sql = 'INSERT INTO receivedPayments (amount, year, month, user_id, isActive, created_at, comments) VALUES (?, ?, ?, ?, 1, now(),?)';
        mysqlConnection.query(sql, [amount, year, month, user_id, comments], (err, result) => {
          if (err) {
           const response = {
            code: -1,
            mensaje: "Error al crear el registro"
            };
            resolve(response)
          } else {
            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
                };    
                resolve(response)            
          }
        });

    })
}


module.exports = { 
    getReceivedPayments, 
    getReceivedPaymentById, 
    updateReceivedPaymentById, 
    deleteReceivedPaymentById, 
    addReceivedPayment
}