const mysqlConnection = require('../config/database');


getServiceById= (id) => {

  return new Promise((resolve, reject) => {
      const query = "select * from servicios where id = ?;";
      mysqlConnection.query(query,[id], (err, rows, fields) => {        
          if(!err){
             
              resolve(rows)
          }else{
              console.log(err)
              reject(err)
          }
      })
  })
}



listActivaService= () => {

    return new Promise((resolve, reject) => {
        const query = "select * from servicios where isActive= 1 order  by nombreServico ;";
        mysqlConnection.query(query, (err, rows, fields) => {        
            if(!err){
               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

listServiceActivaAdditional= () => {

    return new Promise((resolve, reject) => {
        const query = "select * from serviciosadicionales where isActive=1  order by nombreServicio ;";
        mysqlConnection.query(query, (err, rows, fields) => {        
            if(!err){
               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

registraService= (data) => {

    return new Promise((resolve, reject) => {
       
        console.log(data);

        const {  nombreServicio, isActive, costoHora } =data;
        const sql = 'INSERT INTO servicios ( nombreServicio, isActive, costoHora) VALUES ( ?, ?, ?)';
        mysqlConnection.query(sql, [ nombreServicio, isActive, costoHora], (err, result) => {
          if (err) {
           // res.status(400).send('Error al crear el registro');

           const response = {
            code: -1,
            mensaje: "Error al crear el registro"
            };

            resolve(response)
          } else {

            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
                };
    
                resolve(response)

            
          }
        });

    })
}

updateService= (id,data) => {

    return new Promise((resolve, reject) => {
       
        const { nombreServicio, isActive, costoHora } = data;
        const sql = 'UPDATE servicios SET nombreServicio = ?, isActive = ?, costoHora = ? WHERE id = ?';
         mysqlConnection.query(sql, [nombreServicio, isActive, costoHora, id], (err, result) => {
        if (err) {
       
            const response = {
                code: -1,
                mensaje: "Error al crear el registro"
                };
    
                resolve(response)

        } else {
      
            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
                };
    
                resolve(response)
        }
     });

       
 });

    
}

deleteService= (id) => {

    return new Promise((resolve, reject) => {
       
        const sql = 'DELETE FROM servicios WHERE id = ?';
        mysqlConnection.query(sql, id, (err, result) => {
          if (err) {
            
            const response = {
                code: -1,
                mensaje: "Error al eliminar el registro"
                };
    
                resolve(response)

          } else {
            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
            };

            resolve(response)
          }
        });
 });   
}

listService = (page) => {

    var numPerPage = 10;
    var skip = (page - 1) * numPerPage;
    var limit = skip + ',' + numPerPage;
  
    //let userId=data.userId;
  
    return new Promise((resolve, reject) => {

  
    mysqlConnection.query("SELECT count(*) as numRows FROM servicios  " , async function (err, rows, fields) {
  
      if (err) {
        const responseError = {
          code: -1,
          mensaje: err.sqlMessage,
          result: err
  
        };
        resolve(responseError)
      } else {
        var numRows = rows[0].numRows;
        var numPages = Math.ceil(numRows / numPerPage);
  
        const sql01 = "select *  from servicios    order by nombreServicio LIMIT  " + limit;
  
        mysqlConnection.query(sql01, function (err, rows, fields) {
          if (err) {
            const responseError = {
              code: -1,
              mensaje: err.sqlMessage,
              result: err
  
            };
            resolve(responseError)
          } else {
  
  
            const response = {
              code: 0,
              mensaje: "Operacion Existoso",
              page: page,
              numPages: numPages,
              lista: rows
            };
            resolve(response)
  
          }
        });
      }
    });
  
  
    })
  
  }

  registraServiceAdditional= (data) => {

    return new Promise((resolve, reject) => {
       
        const { id, nombreServicio, isActive, costoHora } =data;
        const sql = 'INSERT INTO serviciosadicionales (id, nombreServicio, isActive, costoHora) VALUES (?, ?, ?, ?)';
        mysqlConnection.query(sql, [id, nombreServicio, isActive, costoHora], (err, result) => {
          if (err) {
           // res.status(400).send('Error al crear el registro');

           const response = {
            code: -1,
            mensaje: "Error al crear el registro"
            };

            resolve(response)
          } else {

            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
                };
    
                resolve(response)

            
          }
        });

    })
}

updateServiceAdditional= (id,data) => {

    return new Promise((resolve, reject) => {
       
        const { nombreServicio, isActive, costoHora } = data;
        const sql = 'UPDATE serviciosadicionales SET nombreServicio = ?, isActive = ?, costoHora = ? WHERE id = ?';
         mysqlConnection.query(sql, [nombreServicio, isActive, costoHora, id], (err, result) => {
        if (err) {
       
            const response = {
                code: -1,
                mensaje: "Error al crear el registro"
                };
    
                resolve(response)

        } else {
      
            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
                };
    
                resolve(response)
        }
     });

       
 });

    
}

deleteServiceAdditional= (id) => {

    return new Promise((resolve, reject) => {
       
        const sql = 'DELETE FROM serviciosadicionales WHERE id = ?';
        mysqlConnection.query(sql, id, (err, result) => {
          if (err) {
            
            const response = {
                code: -1,
                mensaje: "Error al eliminar el registro"
                };
    
                resolve(response)

          } else {
            const response = {
                code: 0,
                mensaje: "Registro creado exitosamente"
            };

            resolve(response)
          }
        });
 });   
}

listServiceAdditional = (page) => {

    var numPerPage = 10;
    var skip = (page - 1) * numPerPage;
    var limit = skip + ',' + numPerPage;
  
    //let userId=data.userId;
  
    return new Promise((resolve, reject) => {

  
    mysqlConnection.query("SELECT count(*) as numRows FROM serviciosadicionales  " , async function (err, rows, fields) {
  
      if (err) {
        const responseError = {
          code: -1,
          mensaje: err.sqlMessage,
          result: err
  
        };
        resolve(responseError)
      } else {
        var numRows = rows[0].numRows;
        var numPages = Math.ceil(numRows / numPerPage);
  
        const sql01 = "select *  from serviciosadicionales  order by nombreServicio LIMIT  " + limit;
  
        mysqlConnection.query(sql01, function (err, rows, fields) {
          if (err) {
            const responseError = {
              code: -1,
              mensaje: err.sqlMessage,
              result: err
  
            };
            resolve(responseError)
          } else {
  
  
            const response = {
              code: 0,
              mensaje: "Operacion Existoso",
              page: page,
              numPages: numPages,
              lista: rows
            };
            resolve(response)
  
          }
        });
      }
    });
  
  
    })
  
  }



module.exports = {
    listService,
    registraService,
    updateService,
    deleteService,
    listActivaService,
    registraServiceAdditional,
    updateServiceAdditional,
    deleteServiceAdditional,
    listServiceAdditional,
    listServiceActivaAdditional,
    getServiceById
}