const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');

addService= async (servicio_id,sesiongrabacion_id) => {
    return new Promise((resolve, reject) => {
        const query = 'INSERT INTO reverseserviciosadicionales (serviciosadicionales_id,sesiongrabacion_id) VALUES (?, ?)';
        mysqlConnection.query(query, [servicio_id, sesiongrabacion_id], (error) => {
            if (error) {
                    console.error('Error inserting availability:', error);
                    reject(error)
            } else {                
                resolve({
                    codigo: 0
                })
            }
        });
    })
}
deleteService= async (id, sesionId) => {    
    return new Promise((resolve, reject) => {
            const query = 'delete from reverseserviciosadicionales where serviciosadicionales_id = ? and sesiongrabacion_id = ?;';
            mysqlConnection.query(query, [id, sesionId], (err, result) => {
                if (err) {
                  console.log(err)
                  const response = {
                      code: -1,
                      mensaje: "Error al eliminar el registro"
                      };
          
                      resolve(response)
      
                } else {
                  const response = {
                      code: 0,
                      mensaje: "Registro creado exitosamente"
                  };
      
                  resolve(response)
                }
              });
    })
}


getCheckedServices= (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = "select * from reverseserviciosadicionales where sesiongrabacion_id = ? ";
        mysqlConnection.query(queryPlaca,[id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getCheckedServicesJoined = (id) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = 
        `
        select 
        *
        from reverseserviciosadicionales 
        left join serviciosadicionales
        on serviciosadicionales.id = reverseserviciosadicionales.serviciosadicionales_id
        where reverseserviciosadicionales.sesiongrabacion_id = ?
        order by serviciosadicionales.nombreServicio asc;
        `;
        mysqlConnection.query(queryPlaca,[id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}




deleteAllServicesBySesiondegrabacionId = async (sesiongrabacion_id) => {
    return new Promise((resolve, reject) => {
            const query = 'delete from reverseserviciosadicionales where sesiongrabacion_id = ?;';
            mysqlConnection.query(query, [sesiongrabacion_id], (err, result) => {
                if (err) {
                  console.log(err)
                  const response = {
                      code: -1,
                      mensaje: "Error al eliminar el registro"
                      };
          
                      resolve(response)
      
                } else {
                  const response = {
                      code: 0,
                      mensaje: "Registro creado exitosamente"
                  };
      
                  resolve(response)
                }
              });
    })
}


module.exports = {
    addService,    
    deleteService,
    getCheckedServices,
    getCheckedServicesJoined,
    deleteAllServicesBySesiondegrabacionId
}