
const bcrypt = require('bcrypt');
const mysqlConnection = require('../config/database');


createCita= async (data) => {

    return new Promise((resolve, reject) => {             
        mysqlConnection.query('INSERT INTO sesiongrabacion SET ?', data, function (error, results) {   
            if(!error){
               
                const lastInsertedId = results.insertId;
                resolve({
                    insertedID: lastInsertedId
                })
            }else{
                console.log(error)
                reject(error)
            }
        })
    })
  }
 

getSesiongrabacion= (sesionId) => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `select * from sesiongrabacion where idsesiongrabacion = ${sesionId};`;
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getAllSesionsgrabacionByUserId= (user_id) => {
    return new Promise((resolve, reject) => {
        
        const queryPlaca = `select sesiongrabacion.*,
        (select GROUP_CONCAT(sesiongrabacionfechas.date SEPARATOR ', ')  from sesiongrabacionfechas where sesiongrabacion_id = sesiongrabacion.idsesiongrabacion) as dates , status.name as status,  status.id as estatus_id
        from sesiongrabacion
        left join status on sesiongrabacion.estatus_id = status.id where user_id = ${user_id} 
        order by idsesiongrabacion desc`
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



// select *,
//         (select GROUP_CONCAT(sesiongrabacionfechas.date SEPARATOR ', ') from sesiongrabacionfechas where sesiongrabacion_id = sesiongrabacion.idsesiongrabacion) as dates
//         from sesiongrabacion
//         where estatus = ${id}
//         order by idsesiongrabacion desc


getAllPendingSesionsgrabacionByStatusId = (id) => {
    return new Promise((resolve, reject) => {        
        const queryPlaca = `
        SELECT sesiongrabacion.idsesiongrabacion, nombreBandaGrupo, nombreRepresentante, localidad, telefono, users.email, users.name,
        (select count(*) from cotizaciones where idsesiongrabacion = sesiongrabacion.idsesiongrabacion) as cotizaciones,
        (case when  (sesiongrabacion.whoSoldId = 0 or sesiongrabacion.whoSoldId is null) then 'Sin encargado' else (select name from users where id = sesiongrabacion.whoSoldId ) end) as encargado
        FROM sesiongrabacion left join users on sesiongrabacion.user_id = users.id where estatus_id = ${id} order by sesiongrabacion.idsesiongrabacion desc;`
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}




updateCitaToStatus = async (idsesiongrabacion, estatus_id) => {

    return new Promise((resolve, reject) => {
  
      const query = 'UPDATE sesiongrabacion SET estatus_id = ?  WHERE idsesiongrabacion = ?' ;
  
      mysqlConnection.query(query, [estatus_id, idsesiongrabacion], function (err,rows, result) {   
          if(!err){
             
              resolve({
                codigo: 0
              })
          }else{
            
              reject(err)
          }
      })
  })
}


updateInChargePerson= async (idsesiongrabacion, user_id) => {

    return new Promise((resolve, reject) => {
  
      const query = 'UPDATE sesiongrabacion SET whoSoldId = ?  WHERE idsesiongrabacion = ?' ;
  
      mysqlConnection.query(query, [user_id, idsesiongrabacion], function (err,rows, result) {   
          if(!err){
             
              resolve({
                codigo: 0
              })
          }else{
            
              reject(err)
          }
      })
  })
}

deleteSesionDeGrabacionById = async (idsesiongrabacion) => {

    return new Promise((resolve, reject) => {
  
        const query = 'delete from sesiongrabacion WHERE idsesiongrabacion = ? ;' ;
    
        mysqlConnection.query(query, [idsesiongrabacion], function (err,rows, result) {   
            if(!err){
               
                resolve({
                  codigo: 0
                })
            }else{
              
                reject(err)
            }
        })
    })
}


deleteEmptySesions = async (user_id) => {

    return new Promise((resolve, reject) => {
  
      const query = `delete FROM sesiongrabacion 
      where user_id = ? and
      estatus_id = 1 and 
      nombreBandaGrupo is null and
      nombreRepresentante is null and
      localidad is null and 
      telefono is null and
      (select count(*) from sesiongrabacionfechas where sesiongrabacion_id = sesiongrabacion.idsesiongrabacion) = 0;` ;
  
      mysqlConnection.query(query, [user_id], function (err,rows, result) {   
          if(!err){
             
              resolve({
                codigo: 0
              })
          }else{
            
              reject(err)
          }
      })
  })
}


getAllSesionsgrabacionByQty= (qty) => {
    return new Promise((resolve, reject) => {
        
        const queryPlaca = `
        select  sesiongrabacion.*,
        (select GROUP_CONCAT(sesiongrabacionfechas.date SEPARATOR ', ')  from sesiongrabacionfechas where sesiongrabacion_id = sesiongrabacion.idsesiongrabacion) as dates , 
        status.name as status,  
        status.id as estatus_id,
        (case when users.name is null then 'Sin asignar' else users.name end) as admin
        from sesiongrabacion
        left join status 
        on sesiongrabacion.estatus_id = status.id 	
        left join users 
        on sesiongrabacion.whoSoldId = users.id
        order by idsesiongrabacion desc
		LIMIT ? ;`
        mysqlConnection.query(queryPlaca,[qty], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getServicesToPay = (year, month, user_id) => {
    const query = `
select servicio_id, servicios.nombreServico from sesiongrabacionhorarios horarios
left join servicios 
on horarios.servicio_id = servicios.id
left join sesiongrabacionfechas fechas 
on horarios.sesiongrabacionfechas_id = fechas.id
left join sesiongrabacion sesiones
on fechas.sesiongrabacion_id = sesiones.idsesiongrabacion
where 
    sesiones.estatus_id = 2
    and sesiones.whoSoldId = ?
    and (year(fechas.date) = ? and month(fechas.date) = ?) 
    group by servicio_id, servicios.nombreServico; `;
    return new Promise((resolve, reject) => {
        mysqlConnection.query(query,[user_id, year, month], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}



getServicesToPayGeneral= (year, month) => {
    const query = `
    select count(*) as hours, horarios.servicio_id, sesiones.idsesiongrabacion, sesiones.whoSoldId from sesiongrabacionhorarios horarios
    left join sesiongrabacionfechas fechas 
    on horarios.sesiongrabacionfechas_id = fechas.id
    left join sesiongrabacion sesiones
    on fechas.sesiongrabacion_id = sesiones.idsesiongrabacion
    where 
    sesiones.estatus_id = 2
    and (year(fechas.date) = ? and month(fechas.date) = ?)
    group by horarios.servicio_id, sesiones.idsesiongrabacion, sesiones.whoSoldId; `;
    return new Promise((resolve, reject) => {
        mysqlConnection.query(query,[year, month], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getServicesToPayByUserId= (year, month, user_id) => {
    const query = `
    select count(*) as hours, horarios.servicio_id, sesiones.idsesiongrabacion, sesiones.whoSoldId from sesiongrabacionhorarios horarios
    left join sesiongrabacionfechas fechas 
    on horarios.sesiongrabacionfechas_id = fechas.id
    left join sesiongrabacion sesiones
    on fechas.sesiongrabacion_id = sesiones.idsesiongrabacion
    where 
    sesiones.estatus_id = 2
    and sesiones.whoSoldId = ?
    and (year(fechas.date) = ? and month(fechas.date) = ?)
    group by horarios.servicio_id, sesiones.idsesiongrabacion, sesiones.whoSoldId; `;
    return new Promise((resolve, reject) => {
        mysqlConnection.query(query,[user_id, year, month], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}


getHoursByServiceBySesiongrabacion_id = async (sesiongrabacion_id) => {
    let query = `
    SELECT count(*) as qty, horarios.servicio_id, servicios.nombreServico FROM sesiongrabacionhorarios horarios
    left join sesiongrabacionfechas fechas 
    on horarios.sesiongrabacionfechas_id = fechas.id
    left join servicios
    on horarios.servicio_id = servicios.id
    where fechas.sesiongrabacion_id = ?
    group by horarios.servicio_id, servicios.nombreServico;
    `;
    return new Promise((resolve, reject) => {
        mysqlConnection.query(query,[sesiongrabacion_id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}




updateCita= async (nombreBandaGrupo, nombreRepresentante, localidad, telefono,  idsesiongrabacion, ingeniero_audio) => {

    return new Promise((resolve, reject) => {        
      const query = 'UPDATE sesiongrabacion SET nombreBandaGrupo = ?, nombreRepresentante = ?,  localidad = ?, telefono = ?, ingenieroAudio = ?   WHERE idsesiongrabacion = ?' ;
  
      mysqlConnection.query(query, [nombreBandaGrupo, nombreRepresentante, localidad, telefono,  ingeniero_audio, idsesiongrabacion], function (err,rows, result) {   
          if(!err){
             
              resolve({
                codigo: 0
              })
          }else{
            
              console.log(err)
              reject(err)
          }
      })
  })
}




getIngenierosAudio= () => {
    return new Promise((resolve, reject) => {
        const queryPlaca = `SELECT ingenieroaudio FROM sesiongrabacion
        where ingenieroaudio is not null and ingenieroaudio <> ''
        group by ingenieroaudio`;
        mysqlConnection.query(queryPlaca, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
}

getSesionsToPayByYearMonthUser = (year, month, user_id) => {    

    return new Promise((resolve, reject) => {
        let params = parseInt(user_id) == 0 ? [year, month] :  [user_id, year, month];
        const query = `select sesiones.idsesiongrabacion from sesiongrabacion sesiones
            left join sesiongrabacionfechas fechas 
            on sesiones.idsesiongrabacion = fechas.sesiongrabacion_id
            where  
            sesiones.estatus_id = 2
            ${ parseInt(user_id) == 0 ? '' : ' and sesiones.whoSoldId = ? '  }
            and (year(fechas.date) = ? and month(fechas.date) = ?)
            group by sesiones.idsesiongrabacion 
            order by sesiones.idsesiongrabacion desc;`
        mysqlConnection.query(query, params, (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    });            
}


getSesionToPayById = (id) => {
    return new Promise((resolve, reject) => {
        const query = `select  sesiongrabacion.*,
        (select GROUP_CONCAT(sesiongrabacionfechas.date SEPARATOR ', ')  from sesiongrabacionfechas where sesiongrabacion_id = sesiongrabacion.idsesiongrabacion) as dates , 
        status.name as status,  
        status.id as estatus_id,
        (case when users.name is null then 'Sin asignar' else users.name end) as admin
        from sesiongrabacion
        left join status 
        on sesiongrabacion.estatus_id = status.id 	
        left join users 
        on sesiongrabacion.whoSoldId = users.id
        left join sesiongrabacionfechas fechas 
		on sesiongrabacion.idsesiongrabacion = fechas.sesiongrabacion_id
        where sesiongrabacion.idsesiongrabacion = ?;`
        mysqlConnection.query(query, [id], (err, rows, fields) => {        
            if(!err){               
                resolve(rows)
            }else{
                console.log(err)
                reject(err)
            }
        })
    })
    
}



module.exports = {
    getSesiongrabacion,
    getServicesToPayGeneral,
    updateCita,
    getAllSesionsgrabacionByUserId,
    createCita,
    getAllPendingSesionsgrabacionByStatusId,
    updateCitaToStatus,
    deleteEmptySesions,
    deleteSesionDeGrabacionById,
    getAllSesionsgrabacionByQty,
    getServicesToPay,
    getServicesToPayByUserId,
    updateInChargePerson,
    getHoursByServiceBySesiongrabacion_id,
    getIngenierosAudio,
    getSesionsToPayByYearMonthUser,
    getSesionToPayById
}