const { Router } = require('express');
const router = Router();
const controller = require('../controllers/get.api.controller');
const auth = require('../auth');


router.get('/loadStep2/:id/:sesionId', controller.loadStep2);
router.get('/calendar/:month/:year', controller.calendar);
router.get('/getHorariosByDate/:id?/:date?', controller.getHorariosByDate);
router.get('/getHorariosByDateV2/:id/:date/:locationId/:serviceId', controller.getHorariosByDateV2);
router.get('/getHorariosToUpdate/:fechaId', controller.getHorariosToUpdate);
router.get('/getDraftHorariosa/:id', controller.getDraftHorariosa);
router.get('/getAsistentesMusicos/:id', controller.getAsistentesMusicos);
router.get('/getMusicToEdit/:id', controller.getMusicToEdit);
router.get('/getNoMusicToEdit/:id', controller.getNoMusicToEdit);
router.get('/getAsistentesNoMusicos/:id', controller.getAsistentesNoMusicos);
router.get('/getEquipoestudio/:id', controller.getEquipoestudio);
router.get('/getEquipoestudioEdit/:id', controller.getEquipoestudioEdit);
router.get('/getStep1/:id', controller.getStep1);
router.get('/getStep2/:id', controller.getStep2);
router.get('/getStep3/:id', controller.getStep3);
router.get('/getStep4/:id', controller.getStep4);
router.get('/getStep5/:id', controller.getStep5);
router.get('/downloadCotizacion/:cotizacionId', controller.downloadCotizacion);
router.get('/passwordResetForm/:userId/:ut', controller.passwordResetForm);
router.get('/getFechaYHorarioResumidos', controller.getFechaYHorarioResumidos);
router.get('/acceptSesion/:id', controller.acceptSesion);
router.get('/test', controller.test);
router.get('/changeSesionStatusApprove/:sesiongrabacion_id/:user_id?', controller.changeSesionStatusApprove); 
router.get('/changeSesionStatusEdit/:sesiongrabacion_id', controller.changeSesionStatusEdit); 
router.get('/getCalendars/:year/:month', controller.getCalendars);
router.get('/getBusyDate/:location_id/:year/:month/:dayNumer', controller.getBusyDate);
router.get('/deleteCotizacion/:id/:idsesiongrabacion',auth.isAuthenticated, controller.deleteCotizacion);
router.get('/getAllRecordsByQty/:qty', controller.getAllRecordsByQty);
router.get('/getCalculator/:year/:month/:user_id', controller.getCalculator);
router.get('/getCalculatorV2/:year/:month/:user_id', auth.isAuthenticatedNoRedirect, controller.getCalculatorV2);
router.get('/getAditionalServices/:sesionId', controller.getAditionalServices);
router.get('/getAditionalServiceToEdit/:id', controller.getAditionalServiceToEdit);
router.get('/getAditionalServicesForDisplay/:sesionId', controller.getAditionalServicesForDisplay);
router.get('/getPercentagesByCotizacionId/:id', controller.getPercentagesByCotizacionIdGeneral);
router.get('/editPercentageIndiv/:id', controller.editPercentageIndiv);
router.get('/getReceivedPaymentById/:id', controller.getReceivedPaymentById);
router.get('/getReceivedPayments/:year/:month/:user_id', controller.getReceivedPayments);
router.get('/editReceivedPayment/:id', controller.editReceivedPayment);

//A eliminar
router.get('/getCalculatorV2Raw/:year/:month/:user_id', controller.getCalculatorV2Raw);
module.exports = router;