const { Router } = require('express');
const router = Router();
const controller = require('../controllers/index.views.controller');
const auth = require('../auth');

//------*******************---------------------------------*****************************************************
router.get('/', auth.isNotAuthenticated , controller.login);
router.get('/logout', controller.logout);
router.get('/login/:method?/:id?',auth.isNotAuthenticated,  controller.login);
router.get('/menuv2', auth.isAuthenticated,  controller.menuv2);
router.get('/passwordReset', controller.passwordReset);

router.get('/adminsList', auth.isAuthenticated, controller.adminsList);
router.get('/newAdmin', auth.isAuthenticated, controller.newAdmin);
router.get('/editAdmin/:id', auth.isAuthenticated, controller.editAdmin);


router.get('/paso2/:id?/:from?', auth.isAuthenticated, controller.step2);
router.get('/paso3/:id/:from?', auth.isAuthenticated, controller.step3); 
router.get('/paso4/:id/:from?',auth.isAuthenticated, controller.step4);
router.get('/paso5/:id/:from?',auth.isAuthenticated, controller.step5);
router.get('/paso6/:id/:from?',auth.isAuthenticated, controller.step6);
router.get('/paso7/:id/:from?',auth.isAuthenticated, controller.step7);


router.get('/addHorasYfechas/:idsesiongrabacion', auth.isAuthenticated, controller.addHorasYfechas);
router.get('/updateHorasYfechas/:idsesiongrabacion/:fechaId', auth.isAuthenticated, controller.updateHorasYfechas);


router.get('/calendarios', auth.isAuthenticated, controller.calendarios);
router.get('/mainForm/:id', auth.isAuthenticated, controller.mainForm);


router.get('/services', auth.isAuthenticated, controller.services);
router.get('/newService', auth.isAuthenticated, controller.newService);
router.get('/editService/:serviceId', auth.isAuthenticated, controller.editService);
router.get('/prices/:id', auth.isAuthenticated, controller.prices);


router.get('/cotizacionesMenu/:idsesiongrabacion', auth.isAuthenticated, controller.cotizacionesMenu);
router.get('/cotizacion/:idsesiongrabacion/:cotizacionId?', auth.isAuthenticated, controller.cotizacion);
router.get('/quotePeview/:idsesiongrabacion/:cotizacionId', auth.isAuthenticated, controller.quotePeview);
router.get('/calculator', auth.isAuthenticated, controller.calculator);
router.get('/calculatorv2', auth.isAuthenticated, controller.calculator);

router.get('/quotePeviewexternal/:idsesiongrabacion/:cotizacionId', controller.quotePeviewexternal);
router.get('/menu',auth.isAuthenticated, controller.menu);


router.get('/noticeOfPrivacy', controller.noticeOfPrivacy);
router.get('/unsubscribe', controller.unsubscribe);
router.get('/bitacora/:idsesiongrabacion', controller.bitacora);





module.exports = router;