const express = require('express');
const bodyParser = require('body-parser');
const cors = require('cors');
const path = require('path');
const expressLayouts = require('express-ejs-layouts');
const favicon = require('express-favicon');
const session = require('express-session');
const { PORT } = require('./config')
const app = express();

app.use(session({
  secret: "bunkermx2023", 
  resave: true,
  saveUninitialized: true,
}))



app.use(express.static('./public'));
app.use(favicon(__dirname + '/public/img/cropped-fav-32x32.png'))
app.use('/img', express.static(path.resolve(__dirname, './public/img')));
app.use('/pdfs', express.static(path.resolve(__dirname, './pdfs')));
app.set('views', path.join(__dirname, './views'));
app.engine('html', require('ejs').renderFile);
app.set('view engine', 'ejs');

app.use(expressLayouts);

app.use(cors());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(bodyParser.json());

app.use(require('./routes/index.views.routes'));
app.use(require('./routes/post.api.routes'));
app.use(require('./routes/get.api.routes'));
app.use(require('./routes/delete.api.routes'));
app.use(require('./routes/update.api.routes'));

app.listen(PORT, () => {
  console.log(`Server is running on port ${PORT}`);
});
