const  cotizacionesModelo  = require('../models/cotizaciones');
const  pdfGenerator  = require('../utils/pdfGenerator');


const generateCotizacion = async (cotizacionId) => {
    try {
        let list = await cotizacionesModelo.getCotizacionElementosForPdf(cotizacionId);
        let customer = await cotizacionesModelo.getCustomerDatForPdf(cotizacionId);
        let { totalsTable, currencyMsj } = await cotizacionesModelo.getTotalsForPdf(cotizacionId);
        let msj = await cotizacionesModelo.getCotizacionValidity();
        let data = await cotizacionesModelo.getContactTable();   
        let { pdfsPath, fileName } = await pdfGenerator.generatePdf(list, data, customer, totalsTable, msj, currencyMsj);    
        let cotizacion = await cotizacionesModelo.getCotizacion(cotizacionId)
        let fileNameToDelete = cotizacion[0].fileName;        
        if(fileNameToDelete)
        {
            await pdfGenerator.eliminarArchivo(`.${pdfsPath}${fileNameToDelete}`)
        }
        await cotizacionesModelo.updateCotizacionFileName(cotizacionId, `${fileName}.pdf`)
        return { result: true, fileName: `${fileName}.pdf`, filePath:`${pdfsPath}${fileName}.pdf` }
    } catch (error) {
        console.log(error)
        return { result: false }
    }
}
module.exports = { generateCotizacion }